/*
 * $Id: BallPool.as,v 1.2 2007/09/02 03:58:03 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import org.cove.ape.Group;
  import abagames.util.Actor;
  import abagames.util.ActorPool;
  import abagames.util.Vector;

  /**
   * Ball pool.
   */
  public class BallPool extends ActorPool {
    private var buffer:BitmapData;
    private var field:Field;
    private var player:Player;
    private var fragments:FragmentPool;
    private var particles:ParticlePool;
    private var smallEnergies:SmallEnergyPool;
    private var sound:SoundHandler;
    private var group:Group;

    public function BallPool(n:int, buffer:BitmapData, field:Field, player:Player,
                           fragments:FragmentPool, particles:ParticlePool, smallEnergies:SmallEnergyPool,
                           sound:SoundHandler, group:Group) {
      this.buffer = buffer;
      this.field = field;
      this.player = player;
      this.fragments = fragments;
      this.particles = particles;
      this.smallEnergies = smallEnergies;
      this.sound = sound;
      this.group = group;
      super(n);
    }

    protected override function createActor():Actor {
      return new Ball(buffer, field, player, fragments, particles, smallEnergies, sound, group);
    }

    public function destroy():void {
      var an:int = actorNum;
      for (var i:int = 0; i < an; i++)
        Ball(actors[0]).destroy(false);
    }
  }
}
