/*
 * $Id: Fragment.as,v 1.1.1.1 2007/08/19 01:14:45 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import flash.geom.Rectangle;
  import org.cove.ape.Group;
  import org.cove.ape.CircleParticle;
  import abagames.util.Vector;

  /**
   * Fragment of an explosion of a ball and a mine.
   */
  public class Fragment extends ApeParticleActor {
    private var buffer:BitmapData;
    private var field:Field;
    private var shape:Shape;
    private var stayCnt:int;

    public function Fragment(buffer:BitmapData, field:Field, group:Group) {
      this.buffer = buffer;
      this.field = field;
      shape = new Shape(buffer, field);
      shape.addBox(0, 0, 6, 6, 255, 255, 255);
      _particle = new CircleParticle(0, 0, 6);
      _particle.mass = 0.5;
      setGroup(group);
    }

    public function add(x:Number, y:Number, d:Number, sp:Number, r:int, g:int, b:int):void {
      setPos(x, y);
      addForce(Math.sin(d) * sp, Math.cos(d) * sp);
      addToGroup();
      shape.setColor(r, g, b);
      _particle.visible = false;
      stayCnt = 0;
    }

    public override function update():void {
      super.update();
      if (!field.isInY(_pos.y)) {
        remove();
        return;
      }
      if (Math.abs(_particle.velocity.x) + Math.abs(_particle.velocity.y) < 20) {
        stayCnt++;
        if (stayCnt > 3) {
          remove();
          return;
        }
      }
      shape.draw(_pos);
    }

    public override function remove():void {
      removeFromGroup();
      super.remove();
    }
  }
}
