/*
 * $Id: SmallEnergy.as,v 1.1 2007/09/02 03:58:05 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import org.cove.ape.Group;
  import org.cove.ape.CircleParticle;
  import abagames.util.Vector;

  /**
   * Small energy item.
   */
  public class SmallEnergy extends ApeParticleActor {
    private var buffer:BitmapData;
    private var field:Field;
    private var player:Player;
    private var particles:ParticlePool;
    private var shape:Shape;
    private var stayCnt:int;

    public function SmallEnergy(buffer:BitmapData, field:Field, player:Player,
                              particles:ParticlePool, group:Group) {
      this.buffer = buffer;
      this.field = field;
      this.player = player;
      this.particles = particles;
      shape = new Shape(buffer, field);
      shape.addBox(0, -5, 7, 2, 0, 255, 0);
      shape.addBox(0, 0, 7, 2, 0, 255, 0);
      shape.addBox(0, 5, 7, 2, 0, 255, 0);
      shape.addBox(-5, 0, 2, 10, 0, 255, 0);
      _particle = new CircleParticle(0, 0, 3);
      _particle.mass = 3;
      _particle.friction = 0;
      setGroup(group);
    }

    public function add(x:Number, y:Number, d:Number, sp:Number):void {
      setPos(x, y);
      addForce(Math.sin(d) * sp, Math.cos(d) * sp);
      addToGroup();
      _particle.visible = false;
      stayCnt = 0;
    }

    public override function update():void {
      super.update();
      if (!field.isInYUpper(_pos.y)) {
        remove();
        return;
      }
      if (player.hasCollision && _pos.dist(player.pos) < 30) {
        player.getSmallEnergy();
        for (var i:int = 0; i < 8; i++) {
          var p:Particle = Particle(particles.getInstanceForced());
          p.add(_pos.x, _pos.y, Math.random() * Math.PI * 2, 1, 0, 255, 0, 0.2);
        }
        remove();
        return;
      }
      if (Math.abs(_particle.velocity.x) + Math.abs(_particle.velocity.y) < 1) {
        stayCnt++;
        if (stayCnt > 3) {
          remove();
          return;
        }
      }
      addForce(0, Field.GRAVITY * 2);
      shape.drawDistorted(_pos);
    }

    public override function remove():void {
      removeFromGroup();
      super.remove();
    }
  }
}
