/*
 * $Id: Store.as,v 1.1 2007/09/06 12:35:42 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.net.SharedObject;

  /**
   * Storing high-scores.
   */
  public class Store {
    public static const HIGH_SCORES_NUM:int = 10;
    private static const VERSION_NUM:int = 20;
    private var sharedObject:SharedObject;
    private var data:Object;
    private var _highScores:Array;

    public function Store() {
      sharedObject = SharedObject.getLocal("store");
      data = sharedObject.data;
      load();
    }

    private function load():void {
      if (data.versionNum == null && data.versionNum != VERSION_NUM)
        initData();
      else
        _highScores = data._highScores;
    }

    private function initData():void {
      _highScores = new Array;
      for (var i:int = 0; i < HIGH_SCORES_NUM; i++)
        _highScores.push((10 - i) * 100);
      save();
    }

    public function storeScore(sc:int):void {
      for (var i:int = 0; i < HIGH_SCORES_NUM; i++) {
        if (sc > _highScores[i]) {
          for (var j:int = HIGH_SCORES_NUM - 1; j > i; j--)
            _highScores[j] = _highScores[j -1];
          _highScores[i] = sc;
          save();
          return;
        }
      }
    }

    private function save():void {
      data.versionNum = VERSION_NUM;
      data._highScores = _highScores;
      sharedObject.flush();
    }

    public function get highScores():Array {
      return _highScores;
    }
  }
}
