/*
 * $Id: KeyState.as,v 1.2 2007/09/02 03:58:05 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.util {
  import flash.events.KeyboardEvent;

  /**
   * Handling a key state.
   */
  public class KeyState {
    public var left:Boolean = false;
    public var up:Boolean = false;
    public var right:Boolean = false;
    public var down:Boolean = false;
    public var a:Boolean = false;
    public var esc:Boolean = false;
    public var p:Boolean = false;

    public function onKeyDown(evt:KeyboardEvent):void {
      switch (evt.keyCode) {
      case 0x25:
      case 0x41:
        left = true;
        break;
      case 0x26:
      case 0x57:
        up = true;
        break;
      case 0x27:
      case 0x44:
        right = true;
        break;
      case 0x28:
      case 0x53:
        down = true;
        break;
      case 0x5a:
      case 0xbf:
        a = true;
        break;
      case 0x1b:
        esc = true;
        break;
      case 0x50:
      case 0x43:
        p = true;
        break;
      }
    }

    public function onKeyUp(evt:KeyboardEvent):void {
      switch (evt.keyCode) {
      case 0x25:
      case 0x41:
        left = false;
        break;
      case 0x26:
      case 0x57:
        up = false;
        break;
      case 0x27:
      case 0x44:
        right = false;
        break;
      case 0x28:
      case 0x53:
        down = false;
        break;
      case 0x5a:
      case 0xbf:
        a = false;
        break;
      case 0x1b:
        esc = false;
        break;
      case 0x50:
      case 0x43:
        p = false;
        break;
      }
    }
  }
}
