/*
 * $Id: Vector.as,v 1.1.1.1 2007/08/19 01:14:45 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.util {
  
  /**
   * 2D vector.
   */
  public class Vector {
    public var x:Number = 0;
    public var y:Number = 0;

    public function Vector(x:Number = 0, y:Number = 0) {
      this.x = x;
      this.y = y;
    }

    public function add(p:Vector):void {
      x += p.x;
      y += p.y;
    }

    public function mul(v:Number):void {
      x *= v;
      y *= v;
    }

    public function dist(p:Vector):Number {
      var ox:Number = p.x - x;
      var oy:Number = p.y - y;
      return Math.sqrt(ox * ox + oy * oy);
    }

    public function distRough(p:Vector):Number {
      var ox:Number = Math.abs(p.x - x);
      var oy:Number = Math.abs(p.y - y);
      if (ox > oy)
        return ox + oy / 2;
      else
        return oy + ox / 2;
    }

    public function get sizeRough():Number {
      var ox:Number = Math.abs(x);
      var oy:Number = Math.abs(y);
      if (ox > oy)
        return ox + oy / 2;
      else
        return oy + ox / 2;
    }

    public function checkCross(p:Vector, p1:Vector, p2:Vector, width:Number):Boolean {
      var a1x:Number;
      var a1y:Number;
      var a2x:Number;
      var a2y:Number;
      if (x < p.x) {
        a1x = x - width;
        a2x = p.x + width;
      } else {
        a1x = p.x - width;
        a2x = x + width;
      }
      if (y < p.y) {
        a1y = y - width;
        a2y = p.y + width;
      } else {
        a1y = p.y - width;
        a2y = y + width;
      }
      var b1x:Number;
      var b1y:Number;
      var b2x:Number;
      var b2y:Number;
      if (p2.y < p1.y) {
        b1y = p2.y - width;
        b2y = p1.y + width;
      } else {
        b1y = p1.y - width;
        b2y = p2.y + width;
      }
      if (a2y >= b1y && b2y >= a1y) {
        if (p2.x < p1.x) {
          b1x = p2.x - width;
          b2x = p1.x + width;
        } else {
          b1x = p1.x - width;
          b2x = p2.x + width;
        }
        if (a2x >= b1x && b2x >= a1x) {
          var a:Number = y - p.y;
          var b:Number = p.x - x;
          var c:Number = p.x * y - p.y * x;
          var d:Number = p2.y - p1.y;
          var e:Number = p1.x - p2.x;
          var f:Number = p1.x * p2.y - p1.y * p2.x;
          var dnm:Number = b * d - a * e;
          if (dnm != 0) {
            var x:Number = (b * f - c * e) / dnm;
            var y:Number = (c * d - a * f) / dnm;
            if (a1x <= x && x <= a2x && a1y <= y && y <= a2y &&
                b1x <= x && x <= b2x && b1y <= y && y <= b2y)
              return true;
          }
        }
      }
      return false;
    }
  }
}
